From f306fe3a5fffbb5fd0b216d280a86bec6a20fc46 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:58:10 +0000
Subject: [PATCH 732/1001] Convert the workflow widgets


---

diff --git a/hubs/widgets/workflow/pendingacls.py b/hubs/widgets/workflow/pendingacls.py
index 5bc6594..4676844 100644
--- a/hubs/widgets/workflow/pendingacls.py
+++ b/hubs/widgets/workflow/pendingacls.py
@@ -2,52 +2,67 @@ from __future__ import unicode_literals
 
 import requests
 
-from hubs.hinting import hint, prefixed as _
-from hubs.widgets.base import argument
-from hubs.widgets import templating
+from hubs import validators
 from hubs.utils import username2avatar
+from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.caching import CachedFunction
+from hubs.widgets.chrome import panel
 
-import hubs.validators as validators
 
-from hubs.widgets.chrome import panel
-# If 'pending_acls' is empty, then don't render any chrome.
-chrome = panel('Pending ACL Requests', key='pending_acls')
-# TODO -- add approve/deny buttons or just link through to pkgdb
-template = templating.environment.get_template(
-    'templates/workflow/pendingacls.html')
-position = 'right'
-
-
-@argument(name="username",
-          default=None,
-          validator=validators.username,
-          help="A FAS username.")
-def data(session, widget, username):
-
-    # TODO -- rewrite this to
-    # 1) use the datagrepper API instead of the direct pkgdb API
-    # 2) so that we can use the fedmsg.meta.conglomerate API to
-    # 3) group messages nicely in the UI instead of having repeats
-    # It will be slower, but that's fine because of our smart cache.
-
-    baseurl = "https://admin.fedoraproject.org/pkgdb/api/pendingacls"
-    query = "?username={username}&format=json".format(username=username)
-    url = baseurl + query
-    response = requests.get(url)
-    data = response.json()
-    for acl in data['pending_acls']:
-        acl['avatar'] = username2avatar(acl['user'], s=32)
-    data['username'] = username
-    return data
-
-
-@hint(topics=[_('pkgdb.acl.update')])
-def should_invalidate(message, session, widget):
-    # Search the message to see if I am in the ACLs list of the request.
-    username = widget.config['username']
-
-    for acl in message['msg']['package_listing']['acls']:
-        if acl['fas_name'] == username and acl['status'] == 'Approved':
-            return True
-
-    return False
+class PendingACLs(Widget):
+
+    name = "workflow.pendingacls"
+    position = "right"
+    arguments = [
+        dict(
+            name="username",
+            label="Username",
+            default=None,
+            validator=validators.username,
+            help="A FAS username.",
+        )]
+
+
+class BaseView(WidgetView):
+
+    name = "root"
+    url_rules = ["/"]
+    # TODO -- add approve/deny buttons or just link through to pkgdb
+    template_name = "templates/workflow/pendingacls.html"
+    # If 'pending_acls' is empty, then don't render any chrome.
+    chrome = panel('Pending ACL Requests', key='pending_acls')
+
+    def get_context(self, instance, *args, **kwargs):
+        get_pending = GetPending(instance)
+        context = dict(username=instance.config["username"])
+        context.update(get_pending())
+        return context
+
+
+class GetPending(CachedFunction):
+
+    def execute(self):
+        # TODO -- rewrite this to
+        # 1) use the datagrepper API instead of the direct pkgdb API
+        # 2) so that we can use the fedmsg.meta.conglomerate API to
+        # 3) group messages nicely in the UI instead of having repeats
+        # It will be slower, but that's fine because of our cache.
+        username = self.instance.config["username"]
+        baseurl = "https://admin.fedoraproject.org/pkgdb/api/pendingacls"
+        query = "?username={username}&format=json".format(username=username)
+        url = baseurl + query
+        response = requests.get(url)
+        data = response.json()
+        for acl in data['pending_acls']:
+            acl['avatar'] = username2avatar(acl['user'], s=32)
+        return data
+
+    def should_invalidate(self, message):
+        if not message['topic'].endswith('pkgdb.acl.update'):
+            return False
+        # Search the message to see if I am in the ACLs list of the request.
+        username = self.instance.config["username"]
+        for acl in message['msg']['package_listing']['acls']:
+            if acl['fas_name'] == username and acl['status'] == 'Approved':
+                return True
+        return False
diff --git a/hubs/widgets/workflow/updates2stable.py b/hubs/widgets/workflow/updates2stable.py
index c7df1c3..7bca860 100644
--- a/hubs/widgets/workflow/updates2stable.py
+++ b/hubs/widgets/workflow/updates2stable.py
@@ -2,60 +2,45 @@ from __future__ import unicode_literals
 
 import requests
 
-from hubs.hinting import hint, prefixed as _
-from hubs.widgets.base import argument
-from hubs.widgets import templating
-import hubs.validators as validators
+from hubs import validators
+from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.caching import CachedFunction
+from hubs.widgets.chrome import panel
 
 
-from hubs.widgets.chrome import panel
-# If 'updates' is empty, then don't render any chrome.
-chrome = panel('Updates Ready for Stable', key='updates')
-# TODO -- add approve/deny buttons or just link through to pkgdb
-template = templating.environment.get_template(
-    'templates/workflow/updates2stable.html')
-position = 'right'
-
-# TODO - the bodhi api exposes a new flag we can use instead of scraping comments...
+# TODO - the bodhi api exposes a new flag we can use instead of scraping
+# comments...
 giveaway = 'can be pushed to stable now'
 
 
-@argument(name="username",
-          default=None,
-          validator=validators.username,
-          help="A FAS username.")
-def data(session, widget, username):
-
-    # First, get all of my updates currently in testing.
-    bodhiurl = 'https://bodhi.fedoraproject.org/updates/'
-    query = '?user={username}&status=testing'.format(username=username)
-    url = bodhiurl + query
-    headers = {'Accept': 'application/json'}
-    response = requests.get(url, headers=headers)
-    if response.status_code == 200:
-        data = response.json()
-
-        # Limit this to only the updates that haven't already requested stable
-        # but which can actually be pushed to stable now.
-        data['updates'] = [
-            update for update in data['updates']
-            if update['request'] is None and
-            any([giveaway in comment['text'] for comment in update['comments']])
-        ]
-
-        # Stuff some useful information in there.
-        baseurl = 'https://apps.fedoraproject.org/packages/images/icons/'
-        for update in data['updates']:
-            build = update['builds'][0]
-            nvr = build['nvr']
-            package = parse_nvr(nvr)
-            update['icon'] = baseurl + package[0] + '.png'
-            update['link'] = bodhiurl + update['title']
-
-        return data
-    else:
-        data = {}
-        return data
+class Updates2Stable(Widget):
+
+    name = "workflow.updates2stable"
+    position = "right"
+    arguments = [
+        dict(
+            name="username",
+            label="Username",
+            default=None,
+            validator=validators.username,
+            help="A FAS username.",
+        )]
+
+
+class BaseView(WidgetView):
+
+    name = "root"
+    url_rules = ["/"]
+    # TODO -- add approve/deny buttons or just link through to pkgdb
+    template_name = "templates/workflow/updates2stable.html"
+    # If 'updates' is empty, then don't render any chrome.
+    chrome = panel('Updates Ready for Stable', key='updates')
+
+    def get_context(self, instance, *args, **kwargs):
+        get_pending = GetPending(instance)
+        context = dict(username=instance.config["username"])
+        context.update(get_pending())
+        return context
 
 
 def parse_nvr(nvr):
@@ -64,11 +49,47 @@ def parse_nvr(nvr):
     return ['-'.join(x[:-2]), x[-2], x[-1]]
 
 
-@hint(topics=[_('bodhi.update.comment')])
-def should_invalidate(message, session, widget):
-    if giveaway in message['msg']['comment']['text']:
-        username = widget.config['username']
-        if username == message['msg']['comment']['update_submitter']:
-            return True
-
-    return False
+class GetPending(CachedFunction):
+
+    def execute(self):
+        username = self.instance.config["username"]
+        # First, get all of my updates currently in testing.
+        bodhiurl = 'https://bodhi.fedoraproject.org/updates/'
+        query = '?user={username}&status=testing'.format(username=username)
+        url = bodhiurl + query
+        headers = {'Accept': 'application/json'}
+        response = requests.get(url, headers=headers)
+        if response.status_code == 200:
+            data = response.json()
+
+            # Limit this to only the updates that haven't already requested
+            # stable but which can actually be pushed to stable now.
+            data['updates'] = [
+                update for update in data['updates']
+                if update['request'] is None and
+                any([giveaway in comment['text']
+                     for comment in update['comments']])
+            ]
+
+            # Stuff some useful information in there.
+            baseurl = 'https://apps.fedoraproject.org/packages/images/icons/'
+            for update in data['updates']:
+                build = update['builds'][0]
+                nvr = build['nvr']
+                package = parse_nvr(nvr)
+                update['icon'] = baseurl + package[0] + '.png'
+                update['link'] = bodhiurl + update['title']
+
+            return data
+        else:
+            data = {}
+            return data
+
+    def should_invalidate(self, message):
+        if not message['topic'].endswith('bodhi.update.comment'):
+            return False
+        if giveaway in message['msg']['comment']['text']:
+            username = self.instance.config['username']
+            if username == message['msg']['comment']['update_submitter']:
+                return True
+        return False

